<template>
  <v-btn
    icon="mdi-pencil-outline"
    variant="tonal"
    size="small"
    color="warning"
    class="mr-2"
    @click="isShown = true"
  />

  <v-dialog
    v-model="isShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение объекта"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Название объекта">
          <v-text-field
            v-model="updatedProperty.name"
            :rules="[validateName]"
            :maxlength="MAX_PROPERTY_NAME_LENGTH"
            placeholder="Название"
          />
        </FormRow>

        <FormRow label="Количество мест">
          <NumberInput
            v-model="updatedProperty.capacity"
            mode="integer"
            :min="MIN_PROPERTY_CAPACITY"
            :max="SMALL_INT_SIZE"
            :step="1"
          />
        </FormRow>

        <FormRow label="Назначенный цвет">
          <ColorPicker v-model="updatedProperty.color" />
        </FormRow>

        <Feedback
          :message="feedback"
          type="error"
          classes="mt-4"
        />

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onUpdateClick"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="isShown = false"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, ref, reactive, watch } from 'vue';

import { createStringValidator } from '@/validators';
import { usePropertiesStore } from '@/stores';

import {
  MIN_PROPERTY_NAME_LENGTH,
  MAX_PROPERTY_NAME_LENGTH,
  MIN_PROPERTY_CAPACITY,
  SMALL_INT_SIZE,
} from '@/declarations';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';

import ColorPicker from '@/components/content/ColorPicker.vue';
import NumberInput from '@/components/content/NumberInput.vue';
import Feedback from '@/components/content/Feedback.vue';

const props = defineProps<{ data: IProperty }>();
const propertiesStore = usePropertiesStore();

const validateName = createStringValidator({
  required: true,
  length: { min: MIN_PROPERTY_NAME_LENGTH, max: MAX_PROPERTY_NAME_LENGTH },
});

const isShown = ref(false);
const isLoading = ref(false);
const feedback = ref('');

const updatedProperty = reactive({
  name: props.data.name,
  capacity: props.data.capacity,
  color: props.data.color,
});

const isDataFilled = computed(() => {
  const isNameEntered = validateName(updatedProperty.name) === true;
  const isCapacityEntered = updatedProperty.capacity >= MIN_PROPERTY_CAPACITY;
  const isColorChosen = Boolean(updatedProperty.color);

  return isNameEntered && isCapacityEntered && isColorChosen;
});

const onUpdateClick = async () => {
  isLoading.value = true;

  const { data: { error } } = await propertiesStore.editProperty(props.data.id, {
    name: updatedProperty.name.trim(),
    capacity: updatedProperty.capacity,
    color: updatedProperty.color,
  });

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  isShown.value = false;
};

watch(isShown, () => {
  updatedProperty.name = props.data.name;
  updatedProperty.capacity = props.data.capacity;
  updatedProperty.color = props.data.color;

  feedback.value = '';
});
</script>